"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    initializeType: ()=>initializeType,
    isType: ()=>isType
});
const _traverseTs = require("../traverse/traverse.js");
const _chainableNoOpProxyTs = require("../utils/chainableNoOpProxy.js");
const initializeType = (name, definition, config, scope)=>{
    const root = {
        // temporarily initialize node/flat to aliases that will be included in
        // the final type in case of cyclic resolutions
        node: name,
        flat: [
            [
                "alias",
                name
            ]
        ],
        infer: _chainableNoOpProxyTs.chainableNoOpProxy,
        qualifiedName: `${scope.name}.${name}`,
        definition,
        scope,
        includesMorph: false,
        config
    };
    // dynamically assign a name to the primary traversal function
    const namedTraverse = {
        [name]: (data)=>{
            const state = new _traverseTs.TraversalState(data, namedTraverse);
            return (0, _traverseTs.traverse)(namedTraverse.flat, state) ? {
                data: state.data
            } : {
                problems: state.problems
            };
        }
    }[name];
    return Object.assign(namedTraverse, root);
};
const isType = (value)=>value?.infer === _chainableNoOpProxyTs.chainableNoOpProxy;
