import { TraversalState, traverse } from "../traverse/traverse.js";
import { chainableNoOpProxy } from "../utils/chainableNoOpProxy.js";
export const initializeType = (name, definition, config, scope)=>{
    const root = {
        // temporarily initialize node/flat to aliases that will be included in
        // the final type in case of cyclic resolutions
        node: name,
        flat: [
            [
                "alias",
                name
            ]
        ],
        infer: chainableNoOpProxy,
        qualifiedName: `${scope.name}.${name}`,
        definition,
        scope,
        includesMorph: false,
        config
    };
    // dynamically assign a name to the primary traversal function
    const namedTraverse = {
        [name]: (data)=>{
            const state = new TraversalState(data, namedTraverse);
            return traverse(namedTraverse.flat, state) ? {
                data: state.data
            } : {
                problems: state.problems
            };
        }
    }[name];
    return Object.assign(namedTraverse, root);
};
export const isType = (value)=>value?.infer === chainableNoOpProxy;
